package org.warp.jcwdb;

public interface DBDataOutput<T> {
	int getSize();
	int getType();
	long calculateHash();
	DBWriter<T> getWriter();
	
	static <T> DBDataOutput<T> create(DBWriter<T> writer, int type, int size, long hash) {
		return new DBDataOutput<T>() {

			@Override
			public int getSize() {
				return size;
			}

			@Override
			public int getType() {
				return type;
			}
			
			@Override
			public long calculateHash() {
				return hash;
			}

			@Override
			public DBWriter<T> getWriter() {
				return writer;
			}
			
		};
	}
}
