package org.warp.jcwdb;

public class DBStandardTypes {
	private static final int STD =							0xFFFFF000;
	public static final int BOOLEAN =						STD|	0x000;
	public static final int BYTE =							STD|	0x001;
	public static final int SHORT =							STD|	0x002;
	public static final int CHAR =							STD|	0x003;
	public static final int INTEGER =						STD|	0x004;
	public static final int FLOAT =			 				STD|	0x005;
	public static final int DOUBLE =		 				STD|	0x006;
	public static final int STRING =						STD|	0x007;
	public static final int BYTE_ARRAY =				STD|	0x008;
	public static final int LIGHT_LIST_ARRAY =	STD|	0x009;
	public static final int LIGHT_LIST_BIG =		STD|	0x00A;
	public static final int GENERIC_OBJECT =		STD|	0x00B;

	public static void registerStandardTypes(JCWDatabase db, TypesManager typesManager) {
		typesManager.registerType(String.class, STRING, new DBStringParser());
		typesManager.registerType(LightArrayList.class, LIGHT_LIST_ARRAY, new DBLightArrayListParser(db));
		typesManager.registerType(LightBigList.class, LIGHT_LIST_BIG, new DBLightBigListParser(db));
		typesManager.registerTypeFallback(new DBGenericObjectParser());
	}
}