package org.warp.jcwdb;

import java.io.IOException;
import java.util.function.BiConsumer;
import java.util.function.BiPredicate;
import java.util.function.Consumer;

public interface IndexManager extends Cleanable {
	<T> T get(long index, DBReader<T> reader) throws IOException;
	int getType(long index) throws IOException;
	long getHash(long index) throws IOException;
	<T> long add(DBDataOutput<T> writer) throws IOException;
	<T> FullIndexDetails addAndGetDetails(DBDataOutput<T> writer) throws IOException;
	<T> IndexDetails set(long index, DBDataOutput<T> writer) throws IOException;
	void setFlushingAllowed(long index, boolean isUnloadingAllowed);
	void delete(long index) throws IOException;
	boolean has(long index);
	void close() throws IOException;
}
