package org.warp.jcwdb;

import java.util.Iterator;
import java.util.List;
import java.util.function.Consumer;
import java.util.function.Supplier;

public interface LightList<T> extends List<T> {

	Iterator<EntryReference<T>> iteratorReferences();

	void forEachReference(Consumer<? super EntryReference<T>> action);

	EntryReference<T> addEntry(T o);

	EntryReference<T> set(int setOffset, final EntryReference<T> element);

	boolean remove(EntryReference<T> ref);

	EntryReference<T> getReference(int index);

	EntryReference<T> getReferenceOrInitialize(int index, Supplier<T> initializer);

	int indexOfEntry(EntryReference<T> ref);

	int lastIndexOfEntry(EntryReference<T> ref);

	void appendIndex(long elementIndex);
}
